clear
R = 1000;      % Outer radius of cells in meters
N = 7;
U = 2;
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
max_users = U;
max_it = 500
mu = 0;
sigma = 10;

for mc_it = 1:max_it
     mc_it

     [x, y, btsx, btsy] = big_cell_gen(U, R, N);

     [distance_path_loss_dB, distUserBTS] = propagation_model(x, y, btsx, btsy, N, U);

     shadowing_dB = randn(U,N,N).*sigma + mu;

     h = abs(1 / sqrt(2) * (randn([U, N, N]) + j * randn(U, N, N)));

     PL = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;


     gain_matrix = 10.^(-PL / 10);

     for n = 1:N
         for u = 1:U
             int(u,n) = sum(gain_matrix(u,n,[1:n-1 n+1:N]));
         end
         avg_int_cell(n,mc_it) = mean(int(:,n));
     end
end

GI_est = sum(avg_int_cell(:))/(N*max_it);

% plot(x,y,'x',btsx,btsy,'o')