%function GI_est = G_estimate(x, y)
clc
clear all
R = 1000;       % Outer radius of primary cell in meters
R_p = 600;      % interference protection radius of primary cell in meters
alpha = 50;     % interference protection radius of secondary Transmitter in meters
%N_cu = 10;      % number of CUs
max_N_cu = 20; % max number of CUs
N_cu = 1:1:max_N_cu;
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
max_it = 1e0;
mu = 0;
sigma = 10;

for mc_it = 1:max_it
    mc_it
    for ii = 1:length(N_cu)
        %disp('number of SUs')
        N_cu(ii);
        U(ii) = N_cu(ii) + 1;   % Total number of users
        [x,y] = PU_CU_cell_gen(R, R_p, U(ii));

        [distance_path_loss_dB, distUser] = propagation_model_CR_uplink(x,y,R_p,alpha);
        %close 
        shadowing_dB = randn(U(ii)).*sigma + mu;

        h = abs(1 / sqrt(2) * (randn(U(ii)) + j * randn(U(ii))));

        PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;
        
        %PLdb = -10*log10(PL); Saad + G estimate is the G in the paper?
        gain_matrix = 10.^(-PathLoss / 10);
        
        for u = 1:U(ii)
            %for uu = 1:U
            gain_matrix(u,[1:u-1 u+1:U]);
            int(mc_it,u,ii) = sum(gain_matrix(u,[1:u-1 u+1:U(ii)]));
            %end
        end
    end
end

GI_est_user = mean(int,1);%mean over stat
GI_est_user = permute(GI_est_user, [2, 3, 1] );
GI_est = mean(GI_est_user)%mean over users

figure;
plot(N_cu, GI_est)
%legend('')
xlabel('Number of cognitive users')
ylabel('interference gain estimate')