%function GI_est = G_estimate(x, y)
clc
clear all
R = 1000;       % Outer radius of primary cell in meters
R_p = 600;      % interference protection radius of primary cell in meters
alpha = 50;     % interference protection radius of secondary Transmitter in meters
%N_cu = 10;      % number of CUs
max_dist = 200; % max distance between users
distance_dB = 90:10:max_dist;
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
max_it = 1e1;
mu = 0;
sigma = 10;
U = 10;

for mc_it = 1:max_it
    mc_it
    for jj = 1:length(distance_dB)
        %disp('number of SUs')
        
        % Total number of users
        [x,y] = PU_CU_cell_gen(R, R_p, U);

        [distance_path_loss_dB1, distUser] = propagation_model_CR(x,y,R_p,alpha);
        %close
        
        distance_path_loss_dB = distance_dB(jj) .* ones(U);
        
        shadowing_dB = randn(U).*sigma + mu;

        h = abs(1 / sqrt(2) * (randn(U) + j * randn(U)));

        PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;
        
        gain_matrix = 10.^(-PathLoss / 10);
        
        for u = 1:U
            %for uu = 1:U
            gain_matrix(u,[1:u-1 u+1:U]);
            int(u,mc_it,jj) = sum(gain_matrix(u,[1:u-1 u+1:U]));
            %end
        end
        interf = mean(int,1);%over users
        interference = permute(interf, [2, 3, 1] );
    end
end

GI_est_dist = mean(interference,1);%mean over stat
%GI_est = mean(GI_est_dist)%mean over users

figure;
plot(distance_dB, GI_est_dist)
%legend('')
xlabel('distance in dB')
ylabel('gain estimation')