function [CAP_SU, nb_on_SU, ratio_on_SU, d_cell_comb_int_pwr_SU] = dist_algo_CR_downlink(gain_matrix,rx_pwr_mW,therm_noise_mW,U,Rate,q,P_BS);
% Modified version and more true !!!

% The vector P is initialized by ones (i.e., all users are supposed to be
% on). We then compute the threshold depending on all the SINR we got. We put the
% user "on" or "off" and compute the capacity with respect to the new
% vector P.

% U = total number of users (PU+SUs)
% Rate = Transmission rate
% q = outage probabilty.

% %test
% clear
% clc
% Rate = 0.1;
% q = 0.01;
% U = 6;          % number of users (PU + SUs)
% R = 1000;       % Outer radius of primary cell in meters
% R_p = 600;      % interference protection radius of primary cell in meters
% alpha = 50;     %in meters
% therm_noise_mW = 4.0039e-012;
% maxBTStxPower_mW = 1000;
% gain_matrix = channelgain_CR(R, R_p, U, alpha);
% rx_pwr_mW = maxBTStxPower_mW * gain_matrix;

% P_BS = 10;%ratio between P_BS and P_su
d_on_set(1,:) = ones(1,U);
d_on_set(1) = P_BS;

it_max = 20;
d_Comb_CAP_SU = zeros(1,it_max);
it_convergence = 5;

for it = 1:it_max
    nb_users = length(d_on_set(it,:));
    d_no_on_users(it) = sum(d_on_set(it,2:nb_users)==1);
    %             d_sum_int(u) = 0;
    for u = 2:U
        d_on_set;
        d_sum_int(u) = 0;
        %d_on_set(1,:) = ones(1,u);
        %interference from all other users including PU
        %d_sum_int(u) = sum(gain_matrix(u,[1:u-1]).*d_on_set(it,[1:u-1]))
        %         if U == 2
        %             d_sum_int(2) = P_BS*gain_matrix(2,1);
        %         end

        for m = 1:U
            if m ~= u
                d_sum_int(u) = d_sum_int(u) + gain_matrix(u,m)*d_on_set(it,m);
                %use gain_matrix without multiplication by the
                %power (unlike rx_pwr_mW) as in the formula in (10)
            end
        end

        %         for m = 1:u%interference from all other users including PU
        %             if m ~= u
        %                 d_sum_int(u) = d_sum_int(u) + gain_matrix(u,m)*d_on_set(it,m);%interference
        %             end
        %         end


        d_gain_ratio(it,u) = gain_matrix(u,u)/d_sum_int(u);

        %[max_gain_ratio,user_index(it,u)] = max(d_gain_ratio(it,u));%to delete if we do not ...
        %have any scheduling in the CR scenario
        %replace d_gain_ratio(it,user_index(it,u)) = d_gain_ratio(itu)

        d_cell_ratio(it,u) = ((d_no_on_users(it)+P_BS-1)/(d_no_on_users(it)+P_BS-2))^(d_no_on_users(it)-1);
        d_cell_ratio;
        isinf(d_cell_ratio);
        %abs( log2(1 + d_gain_ratio(it,n)) - d_gain_ratio(it,n))


        if (abs( log2(1 + d_gain_ratio(it,u)) - d_gain_ratio(it,u)) ) < 1e-3

            %disp('low SNR')
            if d_gain_ratio(it,u) < 1 %to modify
                d_on_set(it,u) = 0;
            else
                d_on_set(it,u) = 1;
            end
        else %disp('high SNR')
            if d_gain_ratio(it,u) < d_cell_ratio(it,u)
                d_on_set(it,u) = 0;
            else
                d_on_set(it,u) = 1;
            end
        end
    end
    %d_on_set = [1(PU) * * *(SUs)]
    d_on_set(it+1,:) = d_on_set(it,:);
    d_on_set;

    d_no_it = it;
    if it >= it_convergence
        if d_on_set(it,:) == d_on_set(it-it_convergence+1,:)
            break
        end
    end
end


nb_users = length(d_on_set(1,:));
nb_on_SU = sum(d_on_set(1,2:nb_users)==1);
Pout = 0;

interf=zeros(nb_users,nb_users);                                        %%%%%ADDED

while(nb_on_SU > 0)
    for it = 1:d_no_it
        %     it
        nb_users = length(d_on_set(it,:));
        nb_on_SU = sum(d_on_set(it,2:nb_users)==1);
        for u = 1:nb_users
            d_cell_comb_int_pwr(u) = 0;
            %             if u == 1%equation 1
            %                 for m = 2:nb_users
            %                     d_on_set(it,m);
            %                     d_cell_comb_int_pwr(u) = d_cell_comb_int_pwr(u) + ...
            %                         rx_pwr_mW(u,m)*d_on_set(it,m);%rx_pwr_mW(u,m) channel from m to u ?
            %                 end
            %             else%equation 2 for SU
            for m = 1:nb_users
                if m ~= u
                    d_on_set(it,m);
                    d_cell_comb_int_pwr(u) = d_cell_comb_int_pwr(u) + ...
                        rx_pwr_mW(u,m)*d_on_set(it,m);
                    if it==d_no_it                                       %%%%%ADDED
                        interf(u,m)=rx_pwr_mW(u,m)*d_on_set(it,m);      %%%%%ADDED
                    end                                                 %%%%%ADDED
               end
            end

            d_on_set(it,u);
            d_cell_comb_SINR(it,u) =  rx_pwr_mW(u,u) * d_on_set(it,u)/...
                (therm_noise_mW + d_cell_comb_int_pwr(u));
            d_cell_comb_CAP(it,u) = log2(1 + d_cell_comb_SINR(it,u));
        end
    end

    cap = d_cell_comb_CAP(it,:);
    nb_users = length(d_on_set(it,:));% number of users is taken from the last iteration (it=d_no_it)
    nb_on_SU = sum(d_on_set(it,2:nb_users)==1);
    
    interf
    %int_on=sum(interf').*d_on_set(d_no_it,:);            %%%%%To search for the SU which is more interfered
    %int_of=sum(interf).*d_on_set(d_no_it,:);             %%%%%To search for the SU which generates more interference
    int_on_PU=interf(1,:).*d_on_set(d_no_it,:)          %%%%%To search for the SU which interferes more to the PU

    if nb_on_SU == 0%no SU can Tx
        d_Comb_CAP_SU = 0;
        Pout = 0;
        break
    end
    Pout = probab(d_cell_comb_CAP(:,1), Rate);
    if Pout <= q
        d_Comb_CAP_SU = sum(d_cell_comb_CAP(it,2:nb_users))/nb_on_SU;
     
        break
    else nb_users = nb_users - 1;%here we can choose the worst user to be deleted in term of his interference contribution to the PU
        nb_on_SU = nb_on_SU - 1;
        d_on_set;
        Pout;
        %index_on_row = zeros(size(d_on_set,1),nb_users+1)
        if nb_on_SU == 0%no SU can Tx
            d_Comb_CAP_SU = 0;
            Pout = 0;
            d_on_set = d_on_set(:,1);%there a no more SU in d_on_set
            break
        end
        [max_int,ind_max]=max(int_on_PU(2:end));           %%%%%ADDED
        ind_max=ind_max+1;                          %%%%%ADDED
        d_on_set(:,ind_max)=0;                      %%%%%ADDED
        %for cc = 1:size(d_on_set,1)
        %    index_on_row(cc,:) = find(d_on_set(cc,:));
        %    index_on = index_on_row(cc,1:end-1);
        %    temp(cc,:) = zeros(1,nb_users);
        %    temp(cc,index_on) = 1;
        %    temp(:,1) = P_BS;
        %    d_on_set(cc,:);
        %    clear index_on_row
        %end
        %d_on_set = temp;
        %clear temp;
    end
end

% if nb_on_SU == 0%no SU can Tx
%     Pout = 0
% else
%     Pout = probab(d_cell_comb_CAP(:,1), Rate)
% end

Pout;

% if Pout
%     a = 0;
% end
d_on_set;
ratio_on_SU = nb_on_SU/nb_users;
%nb_on_SU1 = sum(d_on_set(d_no_it,2:nb_users))
nb_on_SU;
CAP_SU = d_Comb_CAP_SU;
if nb_on_SU ~= 0
    d_cell_comb_int_pwr_SU = sum(d_cell_comb_int_pwr)/nb_users;%average interference per user
else
    d_cell_comb_int_pwr_SU = 0;
    CAP_SU = 0;
end