function cg = channelgain_CR_uplink_err(R, R_p, U, alpha,err_std_dev)

% R = 1000;       % Outer radius of primary cell in meters
% R_p = 600;      % interference protection radius of primary cell in meters
% U = 8;          % number of users (PU + SUs)
% alpha = 50;     %in meters
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
mu = 0;         % Mean for lognormal shadowing
sigma = 10;     % S.D. for lognromal shadowing

[x,y] = PU_CU_cell_gen(R, R_p, U);

[distance_path_loss_dB, distUser] = propagation_model_CR_uplink(x, y,R_p,alpha);

shadowing_dB = randn(U).*sigma + mu;

info_imperf=randn(U)*err_std_dev;
%tbn se puede hacer info_imperf=normrnd(media=0,desv std=1e-algo,fil,col)
%distribucion normal (gaussiana) de media cero y desviacion estandar 1e-algo

h = abs(1 / sqrt(2) * (randn(U) + j * randn(U)));

PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;

cg = 10.^(-PathLoss / 10)+ info_imperf;


for fil=1:U
    for col=1:U
        if cg(fil,col)<0
            cg(fil,col)=1e-20;
        end
    end
end