%close all
clear
clc
tic

%%%%%%%% cell parameters %%%%%%%%%%
R = 1000;       % Outer radius of primary cell in meters
R_p = 600;      % interference protection radius of primary cell in meters
alpha = 300;     % interference protection radius of secondary Transmitter in meters
U_max = 11;      % Max number of Users (PU+SUs)
Rate1 = 1;
Rate2 = 3;
Rate3 = 5;
q1 = .01;


for U = 2:U_max%in minimum we have 1 PU + 1 SU = 2
    U
    
    
    boltz_const = 1.3806503*10^(-23);
    T_0 = 290;                                  % ambient temperature in kelvins
    B = 1*10^(6);                               % equivalent bandwidth 1MHz

    
    
    %%%%%%%%%%% Propagation parameters %%%%%%%%%%%%
    maxBTStxPower_mW = 1000; %Pmax in mW
    maxBTStxPower_dBm = 10*log10(maxBTStxPower_mW);% Max. BTS transmission power in dBm for 1 W

    Gtx = 16;                       % Tx antenna gain in dB
    Grx = 6;                        % Rx antenna gain in dB
    therm_noise_mW = boltz_const*T_0*B*1000;                 % thermal noise power in mW = N0 * B
    therm_noise_dBm = 10*log10(therm_noise_mW);              % thermal noise power in dB
    d_Comb_CAP_sys = 0;
    Comb_CAP_sys=0;
    G = 4.5386e-010; %avg over all users
    SNR_avrage_mW = G * maxBTStxPower_mW / therm_noise_mW;
    SNR_avrage_dBm = 10 * log10(SNR_avrage_mW);
    SNR_avrage_dB = SNR_avrage_dBm - 30;
    %[M, MM] = number_variation(SNR_avrage_dB, therm_noise_mW);
    mc_it_max = 1e3;


    for mc_it = 1:mc_it_max
        mc_it
        U;
        
        gain_matrix_uplink = channelgain_CR_uplink(R, R_p, U, alpha);
        gain_matrix_downlink = channelgain_CR_downlink(R, R_p, U, alpha);

        %%%%%%%%% Received power from all possible transmissions %%%%%%%%%%

        rx_pwr_mW_uplink = maxBTStxPower_mW * gain_matrix_uplink;
        rx_pwr_mW_downlink = maxBTStxPower_mW * gain_matrix_downlink;
       
        %%%%%%%% MAX-SINR-ON %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%         for u = 2:U%on SUs only
%             SNR_mW(u) = rx_pwr_mW(u,u)/therm_noise_mW;%SU signal
%             SNR_dB(u) = 10*log10(SNR_mW(u));
% 
%             int_pwr(u) = 0;
%             for m = 1:U%interference from all other users including PU
%                 if m ~= u
%                     int_pwr(u) = int_pwr(u) + rx_pwr_mW(u,m);%interference
%                 end
%             end
%             SINR_mW(u) = rx_pwr_mW(u,u)/(therm_noise_mW + int_pwr(u));
% 
%         end
% 
%         [max_SINR,user_index] = max(SINR_mW, [], 1);
% 
%         for u = 2:U
%             CU_cap(u) = log2(1 + SINR_mW(user_index(u)));
%         end
% 
%         MSO_CAP_sys(mc_it) = mean(CU_cap);


        %%%%%%%% Greedy Algorithm %%%%%%%%%%%

        % [GA_CAP_sys(mc_it), GA_ratio_on_cells(mc_it)] = greedy_algo(rx_pwr_mW,therm_noise_mW,user_index,max_SINR,N);

        %%%%%%% Distributed Algorithm %%%%%%%%%

        % [DA_CAP_sys(mc_it), DA_ratio_on_cells(mc_it)] = dist_algo(gain_matrix,rx_pwr_mW,therm_noise_mW,user_index,N);

        %%%%%%% D-Distributed Algorithm %%%%%%%%%

        % [D_DA_CAP_sys(mc_it), D_DA_ratio_on_cells(mc_it)] = d_dist_algo(gain_matrix,rx_pwr_mW,therm_noise_mW,user_index,N);

        %%%%%%% sch dist Algorithm

        %        [GD_DA_CAP_sys(mc_it), GD_DA_on_cells(mc_it)] = gd_dist_algo_cognitif(gain_matrix,rx_pwr_mW,therm_noise_mW,U,N);
        %         GD_DA_CAP_sys = 1e3.*ones(1,mc_it_max);
        %         GD_DA_CAP_sys2 = 1e3.*ones(1,mc_it_max);
        %         while GD_DA_CAP_sys(mc_it) > 1e2
        [GD_DA_CAP_sys1(mc_it), GD_DA_on_users1(mc_it), ratio_on_SU1(mc_it), d_cell_comb_int_pwr1(mc_it)] = dist_algo_CR_uplink(gain_matrix_uplink,rx_pwr_mW_uplink,therm_noise_mW, U,Rate1,q1,1);
        [GD_DA_CAP_sys2(mc_it), GD_DA_on_users2(mc_it), ratio_on_SU2(mc_it), d_cell_comb_int_pwr2(mc_it)] = dist_algo_CR_uplink(gain_matrix_uplink,rx_pwr_mW_uplink,therm_noise_mW, U,Rate2,q1,1);
        [GD_DA_CAP_sys3(mc_it), GD_DA_on_users3(mc_it), ratio_on_SU3(mc_it), d_cell_comb_int_pwr3(mc_it)] = dist_algo_CR_uplink(gain_matrix_uplink,rx_pwr_mW_uplink,therm_noise_mW, U,Rate3,q1,1);
        %[GD_DA_CAP_sys4(mc_it), GD_DA_on_users4(mc_it), ratio_on_SU4(mc_it)] = dist_algo_uplink(gain_matrix_uplink,rx_pwr_mW_uplink,therm_noise_mW, U,1);
        [GD_DA_CAP_sys11(mc_it), GD_DA_on_users11(mc_it), ratio_on_SU11(mc_it), d_cell_comb_int_pwr11(mc_it)] = dist_algo_CR_downlink(gain_matrix_downlink,rx_pwr_mW_downlink,therm_noise_mW, U,Rate1,q1,10);
        [GD_DA_CAP_sys22(mc_it), GD_DA_on_users22(mc_it), ratio_on_SU22(mc_it), d_cell_comb_int_pwr22(mc_it)] = dist_algo_CR_downlink(gain_matrix_downlink,rx_pwr_mW_downlink,therm_noise_mW, U,Rate2,q1,10);
        [GD_DA_CAP_sys33(mc_it), GD_DA_on_users33(mc_it), ratio_on_SU33(mc_it), d_cell_comb_int_pwr33(mc_it)] = dist_algo_CR_downlink(gain_matrix_downlink,rx_pwr_mW_downlink,therm_noise_mW, U,Rate3,q1,10);
        %[GD_DA_CAP_sys44(mc_it), GD_DA_on_users44(mc_it), ratio_on_SU44(mc_it)] = dist_algo_downlink(gain_matrix_downlink,rx_pwr_mW_downlink,therm_noise_mW, U,10);

        %[Ex_CAP_sys(mc_it), Ex_on_cells(mc_it)] = ex_search(N,U,rx_pwr_mW,therm_noise_mW);

        %%%%%%% e-Distributed Algorithm %%%%%%%%%

        %[E_DA_CAP_sys, E_DA_ratio_on_cells] = e_dist_algo(gain_matrix,rx_pwr_mW,therm_noise_mW,user_index,N);

        %%%%%% Reuse 3 %%%%%%%%%%

        % R3_CAP_sys(mc_it) = fixed_reuse_cap(rx_pwr_mW,3,therm_noise_mW,U,N);

        %%%%%% Reuse 4 %%%%%%%%%%

        % R4_CAP_sys(mc_it) = fixed_reuse_cap(rx_pwr_mW,4,therm_noise_mW,U,N);
    end
    % avg_GA_cap(U) = mean(GA_CAP_sys);
    % avg_dist_cap(U) = mean(DA_CAP_sys);
    % avg_d_dist_cap(U) = mean(D_DA_CAP_sys);
    avg_gd_dist_cap1(U) = mean(GD_DA_CAP_sys1);
    avg_gd_dist_cap2(U) = mean(GD_DA_CAP_sys2);
    avg_gd_dist_cap3(U) = mean(GD_DA_CAP_sys3);
    %avg_gd_dist_cap4(U) = mean(GD_DA_CAP_sys4);
    avg_gd_dist_cap11(U) = mean(GD_DA_CAP_sys11);
    avg_gd_dist_cap22(U) = mean(GD_DA_CAP_sys22);
    avg_gd_dist_cap33(U) = mean(GD_DA_CAP_sys33);
    %avg_gd_dist_cap44(U) = mean(GD_DA_CAP_sys44);
    %    avg_ex_cap(U) = mean(Ex_CAP_sys);
    %avg_e_dist_cap(U) = mean(E_DA_CAP_sys);
    %avg_max_SINR_cap(U) = mean(MSO_CAP_sys);
    % avg_r3_cap(U) = mean(R3_CAP_sys);
    % avg_r4_cap(U) = mean(R4_CAP_sys);

    % avg_GA_ratio_on_cells(U) = mean(GA_ratio_on_cells);
    % avg_dist_ratio_on_cells(U) = mean(DA_ratio_on_cells);
    % avg_d_dist_ratio_on_cells(U) = mean(D_DA_ratio_on_cells);
    avg_gd_dist_on_users1(U) = mean(GD_DA_on_users1);
    avg_gd_dist_on_users2(U) = mean(GD_DA_on_users2);
    avg_gd_dist_on_users3(U) = mean(GD_DA_on_users3);
    %avg_gd_dist_on_users4(U) = mean(GD_DA_on_users4);
    avg_gd_dist_on_users11(U) = mean(GD_DA_on_users11);
    avg_gd_dist_on_users22(U) = mean(GD_DA_on_users22);
    avg_gd_dist_on_users33(U) = mean(GD_DA_on_users33);
    %avg_gd_dist_on_users44(U) = mean(GD_DA_on_users44);
    %avg_ex_dist_on_cells(U) = mean(Ex_on_cells);
    %avg_e_dist_ratio_on_cells(U) = mean(E_DA_ratio_on_cells);


    %Ratio
    avg_ratio_on_SU1(U) = mean(ratio_on_SU1);
    avg_ratio_on_SU2(U) = mean(ratio_on_SU2);
    avg_ratio_on_SU3(U) = mean(ratio_on_SU3);
    %avg_ratio_on_SU4(U) = mean(ratio_on_SU4);
    avg_ratio_on_SU11(U) = mean(ratio_on_SU11);
    avg_ratio_on_SU22(U) = mean(ratio_on_SU22);
    avg_ratio_on_SU33(U) = mean(ratio_on_SU33);
    %avg_ratio_on_SU44(U) = mean(ratio_on_SU44);


   

% interference

    avg_d_cell_comb_int_pwr1(U) = mean(d_cell_comb_int_pwr1);
    avg_d_cell_comb_int_pwr2(U) = mean(d_cell_comb_int_pwr2);
    avg_d_cell_comb_int_pwr3(U) = mean(d_cell_comb_int_pwr3);
    %avg_Pout4(U) = mean(Pout4);
    avg_d_cell_comb_int_pwr11(U) = mean(d_cell_comb_int_pwr11);
    avg_d_cell_comb_int_pwr22(U) = mean(d_cell_comb_int_pwr22);
    avg_d_cell_comb_int_pwr33(U) = mean(d_cell_comb_int_pwr33);
    %avg_Pout44(U) = mean(Pout44);

end

% save('avg_gd_dist_cap1')
% save('avg_gd_dist_cap2')
% save('avg_gd_dist_cap3')
% % save('avg_gd_dist_cap4')
% save('avg_gd_dist_cap11')
% save('avg_gd_dist_cap22')
% save('avg_gd_dist_cap33')
% 
% 
% 
% save('avg_gd_dist_on_users1')
% save('avg_gd_dist_on_users2')
% save('avg_gd_dist_on_users3')
% % save('avg_gd_dist_on_users4')
% save('avg_gd_dist_on_users11')
% save('avg_gd_dist_on_users22')
% save('avg_gd_dist_on_users33')
% 
% save('avg_ratio_on_SU1')
% save('avg_ratio_on_SU2')
% save('avg_ratio_on_SU3')
% % save('avg_gd_dist_on_users4')
% save('avg_ratio_on_SU11')
% save('avg_ratio_on_SU22')
% save('avg_ratio_on_SU33')
% 

figure%capacity
%plot([1:U_max-1],avg_gd_dist_cap4([1:U_max-1]),'r.-')
plot([1:U_max-1], avg_gd_dist_cap1([1:U_max-1]),'b-')
hold on
plot([1:U_max-1],avg_gd_dist_cap2([1:U_max-1]),'g--')
plot([1:U_max-1],avg_gd_dist_cap3([1:U_max-1]),'k-.')
%plot([1:U_max-1],avg_gd_dist_cap44([1:U_max-1]),'r-o')
plot([1:U_max-1],avg_gd_dist_cap11([1:U_max-1]),'b -s')
plot([1:U_max-1],avg_gd_dist_cap22([1:U_max-1]),'g-*')
plot([1:U_max-1],avg_gd_dist_cap33([1:U_max-1]),'k-d')

%plot([1:Max_usrs], avg_ex_cap([1:Max_usrs]),'r-x')%,...
%     [1:Max_usrs-1],avg_e_dist_cap([1:Max_usrs-1]),'g.-',...
%plot([1:Max_usrs],avg_max_SINR_cap,'r-o')

grid
xlabel('Number of Secondary Users')
ylabel('Secondary Users Capacity per active SU (bits/sec/Hz)');
legend('uplink Distributed Algo, q = 1% and R = 0.1 bits/s/Hz',...
    'uplink Distributed Algo, q = 1% and R = 0.3 bits/s/Hz',...
    'uplink Distributed Algo, q = 1% and R = 0.5 bits/s/Hz',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.1 bits/s/Hz',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.3 bits/s/Hz',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.5 bits/s/Hz')
%    'Exhaustive Search',
% Rate1 = 0.1;
% Rate2 = 0.3;
% q1 = 0.1;
% q2 = 0.01;
% Rate1,q1);
% Rate1,q2);
% Rate2,q1);
% legend('Exhaustive Search','Distributed Algo','Distributed Algo using e','MAX-SINR-ON');

% 
% figure%interference
% %plot([1:U_max-1],avg_gd_dist_cap4([1:U_max-1]),'r.-')
% plot([1:U_max-1], avg_d_cell_comb_int_pwr1([1:U_max-1]),'b-')
% hold on
% plot([1:U_max-1],avg_d_cell_comb_int_pwr2([1:U_max-1]),'g--')
% plot([1:U_max-1],avg_d_cell_comb_int_pwr3([1:U_max-1]),'k-.')
% %plot([1:U_max-1],avg_gd_dist_cap44([1:U_max-1]),'r-o')
% plot([1:U_max-1],avg_d_cell_comb_int_pwr11([1:U_max-1]),'b -s')
% plot([1:U_max-1],avg_d_cell_comb_int_pwr22([1:U_max-1]),'g-*')
% plot([1:U_max-1],avg_d_cell_comb_int_pwr33([1:U_max-1]),'k-d')
% 
% %plot([1:Max_usrs], avg_ex_cap([1:Max_usrs]),'r-x')%,...
% %     [1:Max_usrs-1],avg_e_dist_cap([1:Max_usrs-1]),'g.-',...
% %plot([1:Max_usrs],avg_max_SINR_cap,'r-o')
% 
% grid
% xlabel('Number of Secondary Users')
% ylabel('Secondary Users interference per SU (bits/sec/Hz)');
% legend('uplink Distributed Algo, q = 1% and R = 0.1 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.3 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.5 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.1 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.3 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.5 bits/s/Hz')



% figure%only SUs
% %plot(avg_gd_dist_on_users4([1:U_max-1]), avg_gd_dist_cap4([1:U_max-1]),'r.-')
% plot(avg_gd_dist_on_users1([1:U_max-1]), avg_gd_dist_cap1([1:U_max-1]),'b-')
% hold on
% plot(avg_gd_dist_on_users2([1:U_max-1]),avg_gd_dist_cap2([1:U_max-1]),'g--')
% plot(avg_gd_dist_on_users3([1:U_max-1]),avg_gd_dist_cap3([1:U_max-1]),'k-.')
% %plot(avg_gd_dist_on_users44([1:U_max-1]),avg_gd_dist_cap44([1:U_max-1]),'r-o')
% plot(avg_gd_dist_on_users11([1:U_max-1]),avg_gd_dist_cap11([1:U_max-1]),'b -s')
% plot(avg_gd_dist_on_users22([1:U_max-1]),avg_gd_dist_cap22([1:U_max-1]),'g-*')
% plot(avg_gd_dist_on_users33([1:U_max-1]),avg_gd_dist_cap33([1:U_max-1]),'k-d')
% 
% %plot([1:Max_usrs], avg_ex_cap([1:Max_usrs]),'r-x')%,...
% %     [1:Max_usrs-1],avg_e_dist_cap([1:Max_usrs-1]),'g.-',...
% %plot([1:Max_usrs],avg_max_SINR_cap,'r-o')
% 
% grid
% xlabel('Number of active Secondary Users')
% ylabel('Secondary Users Capacity per active SU (bits/sec/Hz)');
% legend(   'uplink Distributed Algo, q = 1% and R = 0.1 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.3 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.5 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.1 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.3 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.5 bits/s/Hz')


% figure%only SUs
% plot(floor(avg_gd_dist_on_users1([1:U_max-1])), avg_gd_dist_cap1([1:U_max-1]),'b-o')
% hold on
% plot(floor(avg_gd_dist_on_users2([1:U_max-1])),avg_gd_dist_cap2([1:U_max-1]),'g -s')
% plot(floor(avg_gd_dist_on_users3([1:U_max-1])),avg_gd_dist_cap3([1:U_max-1]),'k-*')
% %plot(floor(avg_gd_dist_on_users4([1:U_max-1])),avg_gd_dist_cap4([1:U_max-1]),'r-')
% %plot([1:Max_usrs], avg_ex_cap([1:Max_usrs]),'r-x')%,...
% %     [1:Max_usrs-1],avg_e_dist_cap([1:Max_usrs-1]),'g.-',...
% %plot([1:Max_usrs],avg_max_SINR_cap,'r-o')
%
% grid
% xlabel('Number of Active Secondary Users ')
% ylabel('Secondary Users Capacity per active SU (bits/sec/Hz)');
% legend('Distributed Algo with q = 1% and R = 0.1 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.3 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.5 bits/s/Hz',...
%     'Distributed Algo with q = 10% and R = 0.1 bits/s/Hz')






% figure(3)
% plot([2:U_max],floor(avg_gd_dist_on_users1([2:U_max])),'b-o')
% hold on
% plot([2:U_max],floor(avg_gd_dist_on_users2([2:U_max])),'g-s')
% plot([2:U_max],floor(avg_gd_dist_on_users3([2:U_max])),'k -*')
% plot([2:U_max],floor(avg_gd_dist_on_users4([2:U_max])),'r-')
% %plot([1:Max_usrs],avg_ex_dist_on_cells([1:Max_usrs]),'r-x');
% %plot([1:Max_usrs-1],avg_e_dist_ratio_on_cells([1:Max_usrs-1]),'g.-');
% grid
% xlabel('Number of Secondary Users')
% ylabel('Total Active Secondary users')
% legend('Distributed Algo with q = 1% and R = 0.1 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.3 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.5 bits/s/Hz',...
%         'Distributed Algo with q = 10% and R = 0.1 bits/s/Hz')
% %   'Exhaustive Search')

figure
% plot([1:U_max-1],avg_gd_dist_on_users4([1:U_max-1]),'r.-')
plot([1:U_max-1],avg_gd_dist_on_users1([1:U_max-1]),'b-')
hold on
plot([1:U_max-1],avg_gd_dist_on_users2([1:U_max-1]),'g--')
plot([1:U_max-1],avg_gd_dist_on_users3([1:U_max-1]),'k-.')
%plot([1:U_max-1],avg_gd_dist_on_users44([1:U_max-1]),'r-o')
plot([1:U_max-1],avg_gd_dist_on_users11([1:U_max-1]),'b-s')
plot([1:U_max-1],avg_gd_dist_on_users22([1:U_max-1]),'g -*')
plot([1:U_max-1],avg_gd_dist_on_users33([1:U_max-1]),'k-d')
%plot([1:U_max-1],avg_gd_dist_on_users5([1:U_max-1]),'c-')
%plot([1:Max_usrs],avg_ex_dist_on_cells([1:Max_usrs]),'r-x');
%plot([1:Max_usrs-1],avg_e_dist_ratio_on_cells([1:Max_usrs-1]),'g.-');

grid
xlabel('Number of Secondary Users')
ylabel('Number of active Secondary Users')
legend(    'uplink Distributed Algo, q = 1% and R = 0.1 bits/s/Hz',...
    'uplink Distributed Algo, q = 1% and R = 0.3 bits/s/Hz',...
    'uplink Distributed Algo, q = 1% and R = 0.5 bits/s/Hz',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.1 bits/s/Hz',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.3 bits/s/Hz cambiao las rates brutalmente',...
    'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.5 bits/s/Hz')
%   'Exhaustive Search')
%
% figure%only SUs
% plot(avg_ratio_on_SU1([2:U_max]), avg_gd_dist_cap1([2:U_max]),'b-o')
% hold on
% plot(avg_ratio_on_SU2([2:U_max]),avg_gd_dist_cap2([2:U_max]),'g -s')
% plot(avg_ratio_on_SU3([2:U_max]),avg_gd_dist_cap3([2:U_max]),'k-*')
% plot(avg_ratio_on_SU4([2:U_max]),avg_gd_dist_cap4([2:U_max]),'r-')
% %plot([1:Max_usrs], avg_ex_cap([1:Max_usrs]),'r-x')%,...
% %     [1:Max_usrs-1],avg_e_dist_cap([1:Max_usrs-1]),'g.-',...
% %plot([1:Max_usrs],avg_max_SINR_cap,'r-o')
%
% grid
% xlabel('Number of Active Secondary Users ')
% ylabel('Secondary Users Capacity per active SU (bits/sec/Hz)');
% legend('Distributed Algo with q = 1% and R = 0.1 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.3 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.5 bits/s/Hz',...
%     'Distributed Algo with q = 10% and R = 0.1 bits/s/Hz')


%
% figure(4)
% y = [floor(avg_gd_dist_on_users1([2:U_max])) ;floor(avg_gd_dist_on_users3([2:U_max]));...
%     floor(avg_gd_dist_on_users4([2:U_max])) ]
% bar(y','group')
% xlabel('Number of Secondary Users')
% ylabel('Total Active Secondary users')
% legend('Distributed Algo with q = 1% and R = 0.1 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.3 bits/s/Hz',...
%     'Distributed Algo with q = 1% and R = 0.5 bits/s/Hz',...
%         'Distributed Algo with q = 10% and R = 0.1 bits/s/Hz')

%legend('Exhaustive Search', 'Distributed Algo','Distributed Algo using e');

% figure
% % plot([1:U_max-1],avg_ratio_on_SU4([1:U_max-1]),'r.-')
% plot([1:U_max-1],avg_ratio_on_SU1([1:U_max-1]),'b-')
% hold on
% plot([1:U_max-1],avg_ratio_on_SU2([1:U_max-1]),'g--')
% plot([1:U_max-1],avg_ratio_on_SU3([1:U_max-1]),'k-.')
% %plot([1:U_max-1],avg_ratio_on_SU44([1:U_max-1]),'r-o')
% plot([1:U_max-1],avg_ratio_on_SU11([1:U_max-1]),'b-s')
% plot([1:U_max-1],avg_ratio_on_SU22([1:U_max-1]),'g-*')
% plot([1:U_max-1],avg_ratio_on_SU33([1:U_max-1]),'k-d')
% %plot([1:Max_usrs],avg_ex_dist_on_cells([1:Max_usrs]),'r-x');
% %plot([1:Max_usrs-1],avg_e_dist_ratio_on_cells([1:Max_usrs-1]),'g.-');
% grid
% xlabel('Number of Secondary Users')
% ylabel('Ratio of active Secondary Users')
% legend(   'uplink Distributed Algo, q = 1% and R = 0.1 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.3 bits/s/Hz',...
%     'uplink Distributed Algo, q = 1% and R = 0.5 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.1 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.3 bits/s/Hz',...
%     'downlink Distributed Algo with P_{BS} = 10 Watts, q = 1% and R = 0.5 bits/s/Hz')
%   'Exhaustive Search')


toc