%function GI_est = G_estimate(x, y)
clc
% clear all
R = 100;       % Outer radius of primary cell in meters
R_p = 600;      % interference protection radius of primary cell in meters
alpha = 50;     % interference protection radius of secondary Transmitter in meters
%N_cu = 10;      % number of CUs
max_N_cu = 20; % max number of CUs
N_cu = 1:1:max_N_cu;
%N_cu = max_N_cu;
Gtx = 16;       % Tx antenna gain in dB
Grx = 6;        % Rx antenna gain in dB
max_it = 1e0;
mu = 0;
sigma = 10;

for mc_it = 1:max_it
    mc_it
    for ii = 1:length(N_cu)
        %disp('number of SUs')
        N_cu(ii);
        U(ii) = N_cu(ii) + 1;   % Total number of users
        [x,y] = PU_CU_cell_gen(R, R_p, U(ii));

        [distance_path_loss_dB, distUser] = propagation_model_CR_uplink(x,y,R_p,alpha);
        %close
        shadowing_dB = randn(U(ii)).*sigma + mu;

        h = abs(1 / sqrt(2) * (randn(U(ii)) + j * randn(U(ii))));

        PathLoss = distance_path_loss_dB + shadowing_dB + 20.*log10(h) - Gtx - Grx;

        %PLdb = -10*log10(PL); Saad + G estimate is the G in the paper?
        gain_matrix = 10.^(-PathLoss / 10);

        direct(mc_it,ii) = gain_matrix(1,1);
        int(mc_it,ii) = sum(gain_matrix([2:U(ii)], 1));% interference from SU on PU
        
%         for u = 1:U(ii)
%             gain_matrix(u,[1:u-1 u+1:U]);
%             int(mc_it,u,ii) = sum(gain_matrix(u,[1:u-1 u+1:U]));
%         end
    end
end

G_est_int = mean(int,1);%mean over stat
G_est_direct = mean(direct)%mean over stat
G_est_int = permute(G_est_int, [2, 3, 1] );
G_est_int = mean(G_est_int)%mean over users

Gain_PU_SU = mean(G_est_direct./G_est_int)

figure;
plot(N_cu, Gain_PU_SU)
xlabel('Number of cognitive users')
ylabel('PU gain estimate / SU gain estimate')

figure;
plot(N_cu, G_est_int)
hold on
plot(N_cu, G_est_direct,'r')
legend('interference G estimate','direct link G estimate')
xlabel('Number of cognitive users')
ylabel('Channel gain estimate')